/**********************************************************************
** Copyright (C) 2000 Trolltech AS.  All rights reserved.
**
** This file is part of Qtopia Environment.
**
** This file may be distributed and/or modified under the terms of the
** GNU General Public License version 2 as published by the Free Software
** Foundation and appearing in the file LICENSE.GPL included in the
** packaging of this file.
**
** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
**
** See http://www.trolltech.com/gpl/ for GPL licensing information.
**
** Contact info@trolltech.com if any conditions of this licensing are
** not clear to you.
**
**********************************************************************/
#ifndef __LAUNCHER_CLOCK_H__
#define __LAUNCHER_CLOCK_H__

#include <qlabel.h>
#include <qdatetime.h>
#include <qpixmap.h>

#define NUM_ALARMS 4

class AlarmDetails;
class LauncherClock : public QWidget
{
    Q_OBJECT
public:
    LauncherClock( QWidget *parent );
	void setText(const QString& text) { m_text = text; };

protected slots:
    void updateTime( void );
    void slotClockChanged( bool pm );

    void slotEditAlarmsClicked();
    void slotEditAlarmClicked(int alarm);
    void slotSetDateClicked();
	void slotMessage(const QCString& msg, const QByteArray& data);

protected:
    virtual void mousePressEvent( QMouseEvent * );
    virtual void timerEvent( QTimerEvent * );
	virtual void paintEvent ( QPaintEvent* );
    void changeTime( void );
    void readConfig();
    bool ampmFormat;
    int timerId;
    int format;

	void loadAlarms();
	void clearAlarms();

	void reloadAlarms()
	{
		clearAlarms();
		loadAlarms();
	}

	bool hasActiveAlarms();
	QString alarmText(AlarmDetails* alarmDetails);

	AlarmDetails* alarms[NUM_ALARMS];

	QPixmap m_dateTime;
	QPixmap m_alarm;
	QString m_text;
	
    bool m_showAlarm;
};


#endif // __LAUNCHER_CLOCK_H__
